Main Page Modules Class Hierarchy Alphabetical List Compound List File List Compound Members

# SoCone Class Reference
[Nodes]

The SoCone class is for rendering cone shapes. More...

`#include <Inventor/nodes/SoCone.h>`

Inheritance diagram for SoCone:

List of all members.

## Public Types
enum | Part
## Public Methods
| SoCone (void)
void | addPart (SoCone::Part part)
void | removePart (SoCone::Part part)
SbBool | hasPart (SoCone::Part part) const
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
## Static Public Methods
void | initClass (void)
## Public Attributes
SoSFBitMask | parts
SoSFFloat | bottomRadius
SoSFFloat | height
## Protected Methods
virtual | ~SoCone ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

## Detailed Description

The SoCone class is for rendering cone shapes.

Insert a cone shape into the scenegraph. The cone is rendered with the current material, texture and drawstyle settings (if any, otherwise the default settings are used).

The SoCone node class is provided as a convenient abstraction for the application programmer to use "complex" shapes of this type without having to do the tessellation to polygons and other low-level programming herself.

A cone is visualized by the underlying rendering system by first tessellating the conceptual cone into a set of polygons. To control the trade-off between an as much as possible correct visual appearance of the cone versus fast rendering, use an SoComplexity node to influence the number of polygons generated from the tessellation process. (The higher the complexity value, the more polygons will be generated, the more rounded the sides of the cone will look.) Set the SoComplexity::value field to what you believe would be a good trade-off between correctness and speed for your particular application.

See also:
  SoCylinder, SoSphere, SoCube

## Member Enumeration Documentation

enum SoCone::Part

| Enumerates the various parts of the cone, for setting inclusion or exclusion from the shape.

## Constructor & Destructor Documentation

SoCone::SoCone | ( | void |  | ) |

| Constructor.

SoCone::~SoCone | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoCone::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoShape.

void SoCone::addPart | ( | SoCone::Part | part | ) |

| Add a part to the cone. See also: removePart(), hasPart()

void SoCone::removePart | ( | SoCone::Part | part | ) |

| Remove a part from the cone. See also: addPart(), hasPart()

SbBool SoCone::hasPart | ( | SoCone::Part | part | ) | const

| Returns `TRUE` if rendering of the given part is currently turned on. See also: addPart(), removePart()

void SoCone::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoCone::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoCone::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoCone::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

| The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().) The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller. Implements SoShape.

void SoCone::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

| Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box. The bounding box and center point should be calculated and returned in the local coordinate system. The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().) The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry. Implements SoShape.

## Member Data Documentation

SoSFBitMask SoCone::parts

| The parts to use for the cone shape. Defaults to SoCone::ALL.

SoSFFloat SoCone::bottomRadius

| Radius of the cone's bottom disc. Default value is 1.0.

SoSFFloat SoCone::height

| Height of cone. Default value is 2.0.

The documentation for this class was generated from the following files:

- SoCone.h
- SoCone.cpp